; reed_servo_relay_driver.asm  for PIC12F675
; Fuses - WDT enabled, no code protect, Power on reset enabled, 4Mhz intRC osc
; Rx channel input on GPIO3, output 1ms=GPIO0 high,  2ms=GPIO1 high
; via 1k to 2N3914 base, micro-relay in collector to pos 5v
; Phil_G 14/3/2011
;*******************************************************************
;

    LIST    p=12F675 
#include <p12F675.inc>
	__CONFIG  _CP_OFF & _WDT_ON & _BODEN_ON & _PWRTE_ON & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF & _CPD_OFF

	cblock	0x20
posn				; stick position
	endc
	org 0

Start	bsf	STATUS,RP0	; select Register Page 1
	call	3FFh
	movwf	OSCCAL		; calibrate osc
	clrf	ANSEL 		;Digital I/O

	movlw	0x08
	movwf	TRISIO		; Make GPIO3 input & rest outputs
	bcf	STATUS,RP0	; back to Register Page 0

	movlw	07h		; 
	movwf	CMCON 		; switch comparator off
	clrf	GPIO		; all low
frame	clrwdt
	clrf	posn		; clear rx input
; 
; now wait for a rising edge of a new pulse...
;
wait_0	btfsc	GPIO,3		; wait for end of
	goto	wait_0		; any current pulse
wait_1	btfsc	GPIO,3		; wait for start
	goto	meas
	clrwdt
	goto	wait_1		; of new pulse
meas	incf	posn		; (1) inc pw measure
	btfsc	STATUS,Z	; (2) skip if nz
	decf	posn		; overflow if >255
	nop			; (1)
	nop			; (1)
	nop			; (1)
	nop			; (1)
	btfsc	GPIO,3		; (1) pulse end?
	goto	meas		; (2) loop whilst there
				; Total 10 uS per loop
	movlw	.170		; red on at 1.7ms
	subwf	posn,w		; ...if plugged into a neutral channel
	btfsc	STATUS,C	; (2) skip if nc
	goto	setred

	movlw	.130		; green on at 1.3ms
	subwf	posn,w		; ...if plugged into a neutral channel
	btfss	STATUS,C	; (2) skip if nc
	goto	setgrn
	clrf	GPIO		; both relays off at neutral
	goto	frame

setgrn	bsf	GPIO,0		; o/p 0 hi releases 'left' relay if channel < 1.3ms
	bcf	GPIO,1		; o/p 1 lo operates 'right' relay
	goto	frame
setred	bsf	GPIO,1		; o/p 1 hi operates 'left' relay if channel > 1.7ms
	bcf	GPIO,0		; o/p 0 lo releases 'right' relay
	goto	frame

	end
 	